var log = require('..');
var http = require('http');
var fastlog = log.create()
fastlog.to(function(entry) { console.log(entry.message); });


function bench(name, fn, callback) {
  var t = new Date();
  fn();
  var t2 = new Date();
  callback(null, t2 - t);
}

var iters = 100000;
function consolelog() {
  for (var i=0; i < iters; i++) {
    console.log("console");
  }
}

function nanolog() {
  for (var i=0; i < iters; i++) {
    log.info("nanolog");
  }
}

function fastlogloop() {
  for (var i=0; i < iters; i++) {
    fastlog.info("fastlog");
  }
}

bench('console', consolelog, function(err, t) {
  bench('nanolog', nanolog, function(err, t2) {
    bench('fastlog', fastlogloop, function(err, t3) {
      console.warn("times:", t, t2, t3); //, t2, t3);
    });
  });
});




responses = {}
responses['/'] = function(req, res) {
  res.writeHead(200, {'Content-Type': 'text/plain'});
  res.end('Hello World\n');
};
responses['/log'] = function(req, res) {
  console.log('/log');
  res.writeHead(200, {'Content-Type': 'text/plain'});
  res.end('Hello World\n');
};
responses['/nanolog'] = function(req, res) {
  log.info('/nanolog');
  res.writeHead(200, {'Content-Type': 'text/plain'});
  res.end('Hello World\n');
};
responses['/fastlog'] = function(req, res) {
  fastlog.info('/fastlog');
  res.writeHead(200, {'Content-Type': 'text/plain'});
  res.end('Hello World\n');
};


// http.createServer(function (req, res) {
//   console.log(req.url);
//   responses[req.url](req, res)
// }).listen(1337, "127.0.0.1");

// console.log('Server running at http://127.0.0.1:1337/');

